diff --git a/dlls/winegstreamer/wma_decoder.c b/dlls/winegstreamer/wma_decoder.c
index 57b0f204f..021d0beb9 100644
--- a/dlls/winegstreamer/wma_decoder.c
+++ b/dlls/winegstreamer/wma_decoder.c
@@ -624,231 +657,187 @@ static inline struct wma_decoder *impl_from_IMediaObject(IMediaObject *iface)
     return CONTAINING_RECORD(iface, struct wma_decoder, IMediaObject_iface);
 }
 
-static HRESULT WINAPI media_object_QueryInterface(IMediaObject *iface, REFIID iid, void **obj)
+static HRESULT WINAPI wma_media_object_QueryInterface(IMediaObject *iface, REFIID iid, void **obj)
 {
     struct wma_decoder *decoder = impl_from_IMediaObject(iface);
     return IUnknown_QueryInterface(decoder->outer, iid, obj);
 }
 
-static ULONG WINAPI media_object_AddRef(IMediaObject *iface)
+static ULONG WINAPI wma_media_object_AddRef(IMediaObject *iface)
 {
     struct wma_decoder *decoder = impl_from_IMediaObject(iface);
     return IUnknown_AddRef(decoder->outer);
 }
 
-static ULONG WINAPI media_object_Release(IMediaObject *iface)
+static ULONG WINAPI wma_media_object_Release(IMediaObject *iface)
 {
     struct wma_decoder *decoder = impl_from_IMediaObject(iface);
     return IUnknown_Release(decoder->outer);
 }
 
-static HRESULT WINAPI media_object_GetStreamCount(IMediaObject *iface, DWORD *input, DWORD *output)
+static HRESULT WINAPI wma_media_object_GetStreamCount(IMediaObject *iface, DWORD *input, DWORD *output)
 {
-    FIXME("iface %p, input %p, output %p semi-stub!\n", iface, input, output);
+    FIXME("iface %p, input %p, output %p stub!\n", iface, input, output);
     *input = *output = 1;
     return S_OK;
 }
 
-static HRESULT WINAPI media_object_GetInputStreamInfo(IMediaObject *iface, DWORD index, DWORD *flags)
+static HRESULT WINAPI wma_media_object_GetInputStreamInfo(IMediaObject *iface, DWORD index, DWORD *flags)
 {
-    FIXME("iface %p, index %lu, flags %p stub!\n", iface, index, flags);
+    FIXME("iface %p, index %u, flags %p stub!\n", iface, index, flags);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetOutputStreamInfo(IMediaObject *iface, DWORD index, DWORD *flags)
+static HRESULT WINAPI wma_media_object_GetOutputStreamInfo(IMediaObject *iface, DWORD index, DWORD *flags)
 {
-    FIXME("iface %p, index %lu, flags %p stub!\n", iface, index, flags);
+    FIXME("iface %p, index %u, flags %p stub!\n", iface, index, flags);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetInputType(IMediaObject *iface, DWORD index, DWORD type_index,
-        DMO_MEDIA_TYPE *type)
+static HRESULT WINAPI wma_media_object_GetInputType(IMediaObject *iface, DWORD index,
+        DWORD type_index, DMO_MEDIA_TYPE *type)
 {
-    FIXME("iface %p, index %lu, type_index %lu, type %p stub!\n", iface, index, type_index, type);
+    FIXME("iface %p, index %u, type_index %u, type %p stub!\n", iface, index, type_index, type);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetOutputType(IMediaObject *iface, DWORD index, DWORD type_index,
-        DMO_MEDIA_TYPE *type)
+static HRESULT WINAPI wma_media_object_GetOutputType(IMediaObject *iface, DWORD index,
+        DWORD type_index, DMO_MEDIA_TYPE *type)
 {
-    FIXME("iface %p, index %lu, type_index %lu, type %p stub!\n", iface, index, type_index, type);
+    FIXME("iface %p, index %u, type_index %u, type %p stub!\n", iface, index, type_index, type);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_SetInputType(IMediaObject *iface, DWORD index,
+static HRESULT WINAPI wma_media_object_SetInputType(IMediaObject *iface, DWORD index,
         const DMO_MEDIA_TYPE *type, DWORD flags)
 {
-    FIXME("iface %p, index %lu, type %p, flags %#lx stub!\n", iface, index, type, flags);
+    FIXME("iface %p, index %u, type %p, flags %#x stub!\n", iface, index, type, flags);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_SetOutputType(IMediaObject *iface, DWORD index,
+static HRESULT WINAPI wma_media_object_SetOutputType(IMediaObject *iface, DWORD index,
         const DMO_MEDIA_TYPE *type, DWORD flags)
 {
-    FIXME("iface %p, index %lu, type %p, flags %#lx stub!\n", iface, index, type, flags);
+    FIXME("iface %p, index %u, type %p, flags %#x stub!\n", iface, index, type, flags);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetInputCurrentType(IMediaObject *iface, DWORD index, DMO_MEDIA_TYPE *type)
+static HRESULT WINAPI wma_media_object_GetInputCurrentType(IMediaObject *iface, DWORD index, DMO_MEDIA_TYPE *type)
 {
-    FIXME("iface %p, index %lu, type %p stub!\n", iface, index, type);
+    FIXME("iface %p, index %u, type %p stub!\n", iface, index, type);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetOutputCurrentType(IMediaObject *iface, DWORD index, DMO_MEDIA_TYPE *type)
+static HRESULT WINAPI wma_media_object_GetOutputCurrentType(IMediaObject *iface, DWORD index, DMO_MEDIA_TYPE *type)
 {
-    FIXME("iface %p, index %lu, type %p stub!\n", iface, index, type);
+    FIXME("iface %p, index %u, type %p stub!\n", iface, index, type);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetInputSizeInfo(IMediaObject *iface, DWORD index, DWORD *size,
-        DWORD *lookahead, DWORD *alignment)
+static HRESULT WINAPI wma_media_object_GetInputSizeInfo(IMediaObject *iface, DWORD index,
+        DWORD *size, DWORD *lookahead, DWORD *alignment)
 {
-    FIXME("iface %p, index %lu, size %p, lookahead %p, alignment %p stub!\n", iface, index, size,
+    FIXME("iface %p, index %u, size %p, lookahead %p, alignment %p stub!\n", iface, index, size,
             lookahead, alignment);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetOutputSizeInfo(IMediaObject *iface, DWORD index, DWORD *size, DWORD *alignment)
+static HRESULT WINAPI wma_media_object_GetOutputSizeInfo(IMediaObject *iface, DWORD index,
+        DWORD *size, DWORD *alignment)
 {
-    FIXME("iface %p, index %lu, size %p, alignment %p stub!\n", iface, index, size, alignment);
+    FIXME("iface %p, index %u, size %p, alignment %p stub!\n", iface, index, size, alignment);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetInputMaxLatency(IMediaObject *iface, DWORD index, REFERENCE_TIME *latency)
+static HRESULT WINAPI wma_media_object_GetInputMaxLatency(IMediaObject *iface, DWORD index, REFERENCE_TIME *latency)
 {
-    FIXME("iface %p, index %lu, latency %p stub!\n", iface, index, latency);
+    FIXME("iface %p, index %u, latency %p stub!\n", iface, index, latency);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_SetInputMaxLatency(IMediaObject *iface, DWORD index, REFERENCE_TIME latency)
+static HRESULT WINAPI wma_media_object_SetInputMaxLatency(IMediaObject *iface, DWORD index, REFERENCE_TIME latency)
 {
-    FIXME("iface %p, index %lu, latency %s stub!\n", iface, index, wine_dbgstr_longlong(latency));
+    FIXME("iface %p, index %u, latency %s stub!\n", iface, index, wine_dbgstr_longlong(latency));
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_Flush(IMediaObject *iface)
+static HRESULT WINAPI wma_media_object_Flush(IMediaObject *iface)
 {
     FIXME("iface %p stub!\n", iface);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_Discontinuity(IMediaObject *iface, DWORD index)
+static HRESULT WINAPI wma_media_object_Discontinuity(IMediaObject *iface, DWORD index)
 {
-    FIXME("iface %p, index %lu stub!\n", iface, index);
+    FIXME("iface %p, index %u stub!\n", iface, index);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_AllocateStreamingResources(IMediaObject *iface)
+static HRESULT WINAPI wma_media_object_AllocateStreamingResources(IMediaObject *iface)
 {
     FIXME("iface %p stub!\n", iface);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_FreeStreamingResources(IMediaObject *iface)
+static HRESULT WINAPI wma_media_object_FreeStreamingResources(IMediaObject *iface)
 {
     FIXME("iface %p stub!\n", iface);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_GetInputStatus(IMediaObject *iface, DWORD index, DWORD *flags)
+static HRESULT WINAPI wma_media_object_GetInputStatus(IMediaObject *iface, DWORD index, DWORD *flags)
 {
-    FIXME("iface %p, index %lu, flags %p stub!\n", iface, index, flags);
+    FIXME("iface %p, index %u, flags %p stub!\n", iface, index, flags);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_ProcessInput(IMediaObject *iface, DWORD index,
+static HRESULT WINAPI wma_media_object_ProcessInput(IMediaObject *iface, DWORD index,
         IMediaBuffer *buffer, DWORD flags, REFERENCE_TIME timestamp, REFERENCE_TIME timelength)
 {
-    FIXME("iface %p, index %lu, buffer %p, flags %#lx, timestamp %s, timelength %s stub!\n", iface,
+    FIXME("iface %p, index %u, buffer %p, flags %#x, timestamp %s, timelength %s stub!\n", iface,
             index, buffer, flags, wine_dbgstr_longlong(timestamp), wine_dbgstr_longlong(timelength));
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_ProcessOutput(IMediaObject *iface, DWORD flags, DWORD count,
+static HRESULT WINAPI wma_media_object_ProcessOutput(IMediaObject *iface, DWORD flags, DWORD count,
         DMO_OUTPUT_DATA_BUFFER *buffers, DWORD *status)
 {
-    FIXME("iface %p, flags %#lx, count %lu, buffers %p, status %p stub!\n", iface, flags, count, buffers, status);
+    FIXME("iface %p, flags %#x, count %u, buffers %p, status %p stub!\n", iface, flags, count, buffers, status);
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_object_Lock(IMediaObject *iface, LONG lock)
+static HRESULT WINAPI wma_media_object_Lock(IMediaObject *iface, LONG lock)
 {
-    FIXME("iface %p, lock %ld stub!\n", iface, lock);
+    FIXME("iface %p, lock %d stub!\n", iface, lock);
     return E_NOTIMPL;
 }
 
-static const IMediaObjectVtbl media_object_vtbl =
-{
-    media_object_QueryInterface,
-    media_object_AddRef,
-    media_object_Release,
-    media_object_GetStreamCount,
-    media_object_GetInputStreamInfo,
-    media_object_GetOutputStreamInfo,
-    media_object_GetInputType,
-    media_object_GetOutputType,
-    media_object_SetInputType,
-    media_object_SetOutputType,
-    media_object_GetInputCurrentType,
-    media_object_GetOutputCurrentType,
-    media_object_GetInputSizeInfo,
-    media_object_GetOutputSizeInfo,
-    media_object_GetInputMaxLatency,
-    media_object_SetInputMaxLatency,
-    media_object_Flush,
-    media_object_Discontinuity,
-    media_object_AllocateStreamingResources,
-    media_object_FreeStreamingResources,
-    media_object_GetInputStatus,
-    media_object_ProcessInput,
-    media_object_ProcessOutput,
-    media_object_Lock,
-};
-
-static inline struct wma_decoder *impl_from_IPropertyBag(IPropertyBag *iface)
-{
-    return CONTAINING_RECORD(iface, struct wma_decoder, IPropertyBag_iface);
-}
-
-static HRESULT WINAPI property_bag_QueryInterface(IPropertyBag *iface, REFIID iid, void **out)
-{
-    struct wma_decoder *filter = impl_from_IPropertyBag(iface);
-    return IUnknown_QueryInterface(filter->outer, iid, out);
-}
-
-static ULONG WINAPI property_bag_AddRef(IPropertyBag *iface)
-{
-    struct wma_decoder *filter = impl_from_IPropertyBag(iface);
-    return IUnknown_AddRef(filter->outer);
-}
-
-static ULONG WINAPI property_bag_Release(IPropertyBag *iface)
-{
-    struct wma_decoder *filter = impl_from_IPropertyBag(iface);
-    return IUnknown_Release(filter->outer);
-}
-
-static HRESULT WINAPI property_bag_Read(IPropertyBag *iface, const WCHAR *prop_name, VARIANT *value,
-        IErrorLog *error_log)
-{
-    FIXME("iface %p, prop_name %s, value %p, error_log %p stub!\n", iface, debugstr_w(prop_name), value, error_log);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI property_bag_Write(IPropertyBag *iface, const WCHAR *prop_name, VARIANT *value)
-{
-    FIXME("iface %p, prop_name %s, value %p stub!\n", iface, debugstr_w(prop_name), value);
-    return S_OK;
-}
-
-static const IPropertyBagVtbl property_bag_vtbl =
+static const IMediaObjectVtbl wma_media_object_vtbl =
 {
-    property_bag_QueryInterface,
-    property_bag_AddRef,
-    property_bag_Release,
-    property_bag_Read,
-    property_bag_Write,
+    wma_media_object_QueryInterface,
+    wma_media_object_AddRef,
+    wma_media_object_Release,
+    wma_media_object_GetStreamCount,
+    wma_media_object_GetInputStreamInfo,
+    wma_media_object_GetOutputStreamInfo,
+    wma_media_object_GetInputType,
+    wma_media_object_GetOutputType,
+    wma_media_object_SetInputType,
+    wma_media_object_SetOutputType,
+    wma_media_object_GetInputCurrentType,
+    wma_media_object_GetOutputCurrentType,
+    wma_media_object_GetInputSizeInfo,
+    wma_media_object_GetOutputSizeInfo,
+    wma_media_object_GetInputMaxLatency,
+    wma_media_object_SetInputMaxLatency,
+    wma_media_object_Flush,
+    wma_media_object_Discontinuity,
+    wma_media_object_AllocateStreamingResources,
+    wma_media_object_FreeStreamingResources,
+    wma_media_object_GetInputStatus,
+    wma_media_object_ProcessInput,
+    wma_media_object_ProcessOutput,
+    wma_media_object_Lock,
 };
 
 HRESULT wma_decoder_create(IUnknown *outer, IUnknown **out)
@@ -860,10 +849,9 @@ HRESULT wma_decoder_create(IUnknown *outer, IUnknown **out)
     if (!(decoder = calloc(1, sizeof(*decoder))))
         return E_OUTOFMEMORY;
 
-    decoder->IUnknown_inner.lpVtbl = &unknown_vtbl;
-    decoder->IMFTransform_iface.lpVtbl = &transform_vtbl;
-    decoder->IMediaObject_iface.lpVtbl = &media_object_vtbl;
-    decoder->IPropertyBag_iface.lpVtbl = &property_bag_vtbl;
+    decoder->IUnknown_inner.lpVtbl = &wma_unknown_vtbl;
+    decoder->IMFTransform_iface.lpVtbl = &mf_transform_vtbl;
+    decoder->IMediaObject_iface.lpVtbl = &wma_media_object_vtbl;
     decoder->refcount = 1;
     decoder->outer = outer ? outer : &decoder->IUnknown_inner;
 
diff --git a/dlls/winemac.drv/macdrv_main.c b/dlls/winemac.drv/macdrv_main.c
index 50e926c6a..fce8e1023 100644
--- a/dlls/winemac.drv/macdrv_main.c
+++ b/dlls/winemac.drv/macdrv_main.c
@@ -507,3 +507,62 @@ BOOL macdrv_SystemParametersInfo( UINT action, UINT int_param, void *ptr_param,
     }
     return FALSE;
 }
+
+#if defined(__x86_64__) && !defined(__i386_on_x86_64__)
+struct macdrv_functions_t
+{
+    void (*macdrv_init_display_devices)(BOOL);
+    struct macdrv_win_data*(*get_win_data)(HWND hwnd);
+    void (*release_win_data)(struct macdrv_win_data *data);
+    macdrv_window(*macdrv_get_cocoa_window)(HWND hwnd, BOOL require_on_screen);
+    macdrv_metal_device (*macdrv_create_metal_device)(void);
+    void (*macdrv_release_metal_device)(macdrv_metal_device d);
+    macdrv_metal_view (*macdrv_view_create_metal_view)(macdrv_view v, macdrv_metal_device d);
+    macdrv_metal_layer (*macdrv_view_get_metal_layer)(macdrv_metal_view v);
+    void (*macdrv_view_release_metal_view)(macdrv_metal_view v);
+    void (*on_main_thread)(dispatch_block_t b);
+    LSTATUS(WINAPI*RegQueryValueExA)(HKEY, LPCSTR, LPDWORD, LPDWORD, BYTE*, LPDWORD);
+    LSTATUS(WINAPI*RegSetValueExA)(HKEY, LPCSTR, DWORD, DWORD, const BYTE*, DWORD);
+    LSTATUS(WINAPI*RegOpenKeyExA)(HKEY, LPCSTR, DWORD, DWORD, HKEY*);
+    LSTATUS(WINAPI*RegCreateKeyExA)(HKEY, LPCSTR, DWORD, LPSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, HKEY*, LPDWORD);
+    LSTATUS(WINAPI*RegCloseKey)(HKEY);
+    BOOL(WINAPI*EnumDisplayMonitors)(HDC,LPRECT,MONITORENUMPROC,LPARAM);
+    BOOL(WINAPI*GetMonitorInfoA)(HMONITOR,LPMONITORINFO);
+    BOOL(WINAPI*AdjustWindowRectEx)(LPRECT,DWORD,BOOL,DWORD);
+    LONG_PTR(WINAPI*GetWindowLongPtrW)(HWND,int);
+    BOOL(WINAPI*GetWindowRect)(HWND,LPRECT);
+    BOOL(WINAPI*MoveWindow)(HWND,int,int,int,int,BOOL);
+    BOOL(WINAPI*SetWindowPos)(HWND,HWND,int,int,int,int,UINT);
+    INT(WINAPI*GetSystemMetrics)(INT);
+    LONG_PTR(WINAPI*SetWindowLongPtrW)(HWND,INT,LONG_PTR);
+};
+
+void OnMainThread(dispatch_block_t);
+
+struct macdrv_functions_t macdrv_functions = {
+    &macdrv_init_display_devices,
+    &get_win_data,
+    &release_win_data,
+    &macdrv_get_cocoa_window,
+    &macdrv_create_metal_device,
+    &macdrv_release_metal_device,
+    &macdrv_view_create_metal_view,
+    &macdrv_view_get_metal_layer,
+    &macdrv_view_release_metal_view,
+    &OnMainThread,
+    &RegQueryValueExA,
+    &RegSetValueExA,
+    &RegOpenKeyExA,
+    &RegCreateKeyExA,
+    &RegCloseKey,
+    &EnumDisplayMonitors,
+    &GetMonitorInfoA,
+    &AdjustWindowRectEx,
+    &GetWindowLongPtrW,
+    &GetWindowRect,
+    &MoveWindow,
+    &SetWindowPos,
+    &GetSystemMetrics,
+    &SetWindowLongPtrW,
+};
+#endif
\ No newline at end of file
diff --git a/dlls/wintrust/softpub.c b/dlls/wintrust/softpub.c
index 53df5e7fe..06b178a98 100644
--- a/dlls/wintrust/softpub.c
+++ b/dlls/wintrust/softpub.c
@@ -830,16 +830,93 @@ static DWORD WINTRUST_VerifySigner(CRYPT_PROVIDER_DATA *data, DWORD signerIdx)
     return err;
 }
 
+static void load_secondary_signatures(CRYPT_PROVIDER_DATA *data, HCRYPTMSG msg)
+{
+    CRYPT_PROVIDER_SIGSTATE *s = data->pSigState;
+    CRYPT_ATTRIBUTES *attrs;
+    unsigned int i, j;
+    DWORD size;
+
+    if (!CryptMsgGetParam(msg, CMSG_SIGNER_UNAUTH_ATTR_PARAM, 0, NULL, &size))
+        return;
+
+    if (!(attrs = data->psPfns->pfnAlloc(size)))
+    {
+        ERR("No memory.\n");
+        return;
+    }
+    if (!CryptMsgGetParam(msg, CMSG_SIGNER_UNAUTH_ATTR_PARAM, 0, attrs, &size))
+        goto done;
+
+    for (i = 0; i < attrs->cAttr; ++i)
+    {
+        if (strcmp(attrs->rgAttr[i].pszObjId, szOID_NESTED_SIGNATURE))
+            continue;
+
+        if (!(s->rhSecondarySigs = data->psPfns->pfnAlloc(attrs->rgAttr[i].cValue * sizeof(*s->rhSecondarySigs))))
+        {
+            ERR("No memory");
+            goto done;
+        }
+        s->cSecondarySigs = 0;
+        for (j = 0; j < attrs->rgAttr[i].cValue; ++j)
+        {
+            if (!(msg = CryptMsgOpenToDecode(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, 0, 0, NULL, NULL)))
+            {
+                ERR("Could not create crypt message.\n");
+                goto done;
+            }
+            if (!CryptMsgUpdate(msg, attrs->rgAttr[i].rgValue[j].pbData, attrs->rgAttr[i].rgValue[j].cbData, TRUE))
+            {
+                ERR("Could not update crypt message, err %lu.\n", GetLastError());
+                CryptMsgClose(msg);
+                goto done;
+            }
+            s->rhSecondarySigs[j] = msg;
+            ++s->cSecondarySigs;
+        }
+        break;
+    }
+done:
+    data->psPfns->pfnFree(attrs);
+}
+
 HRESULT WINAPI SoftpubLoadSignature(CRYPT_PROVIDER_DATA *data)
 {
-    DWORD err;
+    DWORD err = ERROR_SUCCESS;
 
     TRACE("(%p)\n", data);
 
     if (!data->padwTrustStepErrors)
         return S_FALSE;
 
-    if (data->hMsg)
+    if (data->pSigState)
+    {
+        /* We did not initialize this, probably an unsupported usage. */
+        FIXME("pSigState %p already initialized.\n", data->pSigState);
+    }
+    if (!(data->pSigState = data->psPfns->pfnAlloc(sizeof(*data->pSigState))))
+    {
+        err = ERROR_OUTOFMEMORY;
+    }
+    else
+    {
+        data->pSigState->cbStruct = sizeof(*data->pSigState);
+        data->pSigState->fSupportMultiSig = TRUE;
+        data->pSigState->dwCryptoPolicySupport = WSS_SIGTRUST_SUPPORT | WSS_OBJTRUST_SUPPORT | WSS_CERTTRUST_SUPPORT;
+        if (data->hMsg)
+        {
+            data->pSigState->hPrimarySig = CryptMsgDuplicate(data->hMsg);
+            load_secondary_signatures(data, data->pSigState->hPrimarySig);
+        }
+        if (data->pSigSettings)
+        {
+            if (data->pSigSettings->dwFlags & WSS_GET_SECONDARY_SIG_COUNT)
+                data->pSigSettings->cSecondarySigs = data->pSigState->cSecondarySigs;
+        }
+    }
+
+    if (!err && data->hMsg)
     {
         DWORD signerCount, size;
 
@@ -859,8 +936,7 @@ HRESULT WINAPI SoftpubLoadSignature(CRYPT_PROVIDER_DATA *data)
         else
             err = TRUST_E_NOSIGNATURE;
     }
-    else
-        err = ERROR_SUCCESS;
+
     if (err)
         data->padwTrustStepErrors[TRUSTERROR_STEP_FINAL_SIGPROV] = err;
     return !err ? S_OK : S_FALSE;
@@ -1375,6 +1451,13 @@ HRESULT WINAPI SoftpubCleanup(CRYPT_PROVIDER_DATA *data)
         data->psPfns->pfnFree(data->u.pPDSip->psIndirectData);
     }
 
+    if (WVT_ISINSTRUCT(CRYPT_PROVIDER_DATA, data->cbStruct, pSigState) && data->pSigState)
+    {
+        CryptMsgClose(data->pSigState->hPrimarySig);
+        for (i = 0; i < data->pSigState->cSecondarySigs; ++i)
+            CryptMsgClose(data->pSigState->rhSecondarySigs[i]);
+        data->psPfns->pfnFree(data->pSigState);
+    }
     CryptMsgClose(data->hMsg);
 
     if (data->fOpenedFile &&
